<?php

require_once("lib/http.php");

function multisearch_getmoduleinfo()
{
	$info = array(
		"name"=>"Multiaccount search",
		"author"=>"`2R`@o`ghe`2n `Qvon `2Fa`@lk`genbr`@uch`0",
		"version"=>"1.1",
		"category"=>"Administrative",
		"download"=>"http://www.lotgd.de/downloads/multisearch.zip",
		"prefs"=>array(
			"Multiuser Suche - Allgemein,title",
			"inprocess"=>"In Arbeit durch",
			"useragent" => "Browser-Version"),
		"settings"=>array(
			"Multiuser Suche - Allgemeine Einstellungen,title",
			"daten"=>"Daten - Array (serialisiert)",
			"lastdata"=>"Von wann sind die letzten Daten,date"
		)
	);
	return $info;
}

function multisearch_install() {
	module_addhook("newday");
	module_addhook("superuser");
	return true;
}

function multisearch_uninstall() {
	return true;
}

function multisearch_dohook($hookname,$args) {
	global $session;
	switch($hookname) {
		case "newday":
			set_module_pref("useragent",$_SERVER['HTTP_USER_AGENT']);
			break;
		case 'superuser':
			if($session['user']['superuser'] & SU_EDIT_USERS) {
				addnav("Actions");
				addnav("Multiuser Suche","runmodule.php?module=multisearch");
			}
			break;
	}
	return $args;
}

function multisearch_run() {
	global $session;

	page_header("Multiuser Suche");
	//Seitenaufbau und Navigation
	require_once("lib/superusernav.php");
	superusernav();

	$daten=unserialize(get_module_setting("daten"));
	$op=httpget("op");

	$lastdata=get_module_setting("lastdata");
	if (is_array($daten)==false || $lastdate < date("Y-m-d H:i:s",strtotime("-10 minutes"))) {
	 	set_module_setting("lastdata",date("Y-m-d H:i:s"));
		//Daten zusammenstellen
		$daten=array();
		$daten['password']=array();
		$daten['lastip']=array();
		$daten['uniqueid']=array();
		$daten['accounts']=array();
		
		$password_selection	= "";
		$ip_selection 		= "";
		$system_selection	= "";
		
		$accounts=db_prefix("accounts");
		$module_userprefs=db_prefix("module_userprefs");
		
		//Doppelte Passwrter
		$sql="SELECT password, count(*) As Anzahl FROM $accounts as a INNER JOIN $module_userprefs as mu ON a.acctid=mu.userid AND mu.modulename='rpcontrol' and setting='isrp_char' and value<>'1' GROUP BY password  HAVING Anzahl>1";
		$result=db_query($sql);
		while ($row=db_fetch_assoc($result)) {
			$daten['password'][$row['password']]=$row['Anzahl'];
			if (strlen($password_selection)>0) $password_selection .= ',';
			$password_selection .= "'" . $row['password'] . "'";
		}
		//Doppelte IPs
		$sql="SELECT lastip, count(*) As Anzahl FROM $accounts as a INNER JOIN $module_userprefs as mu ON a.acctid=mu.userid AND mu.modulename='rpcontrol' and setting='isrp_char' and value<>'1' GROUP BY lastip HAVING Anzahl>1";
		$result=db_query($sql);
		while ($row=db_fetch_assoc($result)) {
			$daten['lastip'][$row['lastip']]=$row['Anzahl'];
			if (strlen($ip_selection)>0) $ip_selection .= ',';
			$ip_selection .= "'" . $row['lastip'] . "'";
		}		

		//Doppelte System-IDs
		$sql="SELECT uniqueid, count(*) As Anzahl FROM $accounts as a INNER JOIN $module_userprefs as mu ON a.acctid=mu.userid AND mu.modulename='rpcontrol' and setting='isrp_char' and value<>'1' GROUP BY uniqueid HAVING Anzahl>1";
		$result=db_query($sql);
		while ($row=db_fetch_assoc($result)) {
			$daten['uniqueid'][$row['uniqueid']]=$row['Anzahl'];
			if (strlen($system_selection)>0) $system_selection .= ',';
			$system_selection .= "'" . $row['uniqueid'] . "'";
		}		

		//Abrufen der Accountdaten, die zu den doppelten Eintrgen passen und in die Suchdaten eintragen
		$sql  = "SELECT acctid, name, lastip, uniqueid, laston, password, locked, emailaddress, mub.value as browser, muu.value as multiuser ";
		$sql .= " FROM $accounts as a ";
		$sql .= " LEFT JOIN $module_userprefs as mub ON a.acctid=mub.userid AND mub.modulename='multisearch' AND mub.setting='useragent'";
		$sql .= " LEFT JOIN $module_userprefs as muu ON a.acctid=muu.userid AND muu.modulename='multiaccount' AND muu.setting='allowmultiuser'";
		$sql .= " INNER JOIN $module_userprefs as mur ON a.acctid=mur.userid AND mur.modulename='rpcontrol' and mur.setting='isrp_char' and mur.value<>'1'";
		$sql .= " WHERE password IN ($password_selection) OR lastip IN ($ip_selection) OR uniqueid IN ($system_selection)";
		$sql .= " ORDER BY acctid ASC";
		$result=db_query($sql);
		while ($row=db_fetch_assoc($result)) {
			$daten['accounts'][]=$row;
		}
		set_module_setting("daten",serialize($daten));
	}
	addnav("Sortierung");
	addnav("Nach Passwort","runmodule.php?module=multisearch&op=password");
	addnav("Nach IP","runmodule.php?module=multisearch&op=lastip");
	addnav("Nach UniqueID","runmodule.php?module=multisearch&op=uniqueid");

	$detail=httpget('detail');
	output_grid($daten[$op],$daten['accounts'], $op, $detail);
	page_footer();
}

function output_grid($group, $daten, $identifyfield, $detail) {
	//Kopf aufbauen
 	rawoutput("<table border=0 cellspacing=0 cellpadding=3>");
	rawoutput("<tr class='trhead'>");
	rawoutput("<td colspan=2>" . translate_inline("Name") . "</td>", true);
	rawoutput("<td colspan=2>" . translate_inline("Informationen") . "</td>", true);
	rawoutput("</tr>");

 	foreach($group as $key=>$val) {
 	 	If ($detail=="" || $detail==$key) {
 	 	 	$uid=array();
 	 	 	$ip=array();
 	 	 	$pass=array();
 	 	 	
			//Gruppenblock
			addnav("","runmodule.php?module=multisearch&op={$identifyfield}&detail={$key}");
			rawoutput("<tr><td colspan=4><br></td></tr>");
			rawoutput("<tr class='trdark'>");
			rawoutput("<td colspan=4>");
			output("Gruppe ");
			rawoutput("<a href='runmodule.php?module=multisearch&op={$identifyfield}&detail={$key}'>" . $key . "</a>");
			output(" Vorkommen: %s",$val);
			rawoutput("</td></tr>");
			//Spielerdaten ausgeben, die auf dieses Kriterium passen
			foreach($daten as $keydata=>$valdata) {
				if ($valdata[$identifyfield]==$key) {
					addnav("","user.php?op=edit&userid={$valdata['acctid']}");	
					//Name
		  			rawoutput("<tr><td colspan=2>(<a href='user.php?op=edit&userid={$valdata['acctid']}'>" . $valdata['acctid'] . '</a>)');
	  				output_notl($valdata['name']);
	  				rawoutput("</td><td colspan=2>");
	  				output("Browser: %s",$valdata['browser']);
	  				rawoutput("</td></tr>");
	  				//2. Zeile
					rawoutput("<tr><td></td><td>");
	  				output("Multiuser %s",$valdata['multiuser']==1?translate_inline('ja'):translate_inline('nein'));					
					rawoutput("</td><td>");
					output("E-Mail: %s",$valdata['emailaddress']);
					rawoutput("</td></tr>");	  				
	  				//3. Zeile
					rawoutput("<tr><td></td><td>");
	  				output("Gesperrt: %s",$valdata['locked']==1?translate_inline('ja'):translate_inline('nein'));
					rawoutput("</td><td>");
					if (in_array($valdata['uniqueid'],$uid)==true) {
						output("System ID: `\$%s`0",$valdata['uniqueid']);
					} else {
						output("System ID: %s",$valdata['uniqueid']);
						$uid[]=$valdata['uniqueid'];
					}
					rawoutput("</td></tr>");	  				
	  				//4. Zeile
					rawoutput("<tr><td></td><td>");
					if (in_array($valdata['lastip'],$ip)==true) {
						output("IP: `\$%s`0",$valdata['lastip']);
					} else {
						output("IP: %s",$valdata['lastip']);
						$ip[]=$valdata['lastip'];
					}
					rawoutput("</td><td>");
					if (in_array($valdata['password'],$pass)==true) {
						output("Passwort: `\$%s`0",$valdata['password']);
					} else {
						output("Passwort: %s",$valdata['password']);
						$pass[]=$valdata['password'];
					}
					rawoutput("</td></tr>");	  					  				
					rawoutput("<tr><td colspan=4></td></tr>");
				} //passt auf Gruppe
	 		}	//daten-foreach
		}	//detail oder alles
	} //group
	rawoutput("</table>");	

	//  			if (in_array($row['uniqueid'],$uid)==true) {
	//  				output_notl("`$%s`0",$row['uniqueid']);
	//  			} else {
	//  				$uid[]=$row['uniqueid'];
	//  				output_notl("%s",$row['uniqueid']);
	//  			}
	//  			rawoutput("</td><td>");
	//  			if (in_array($row['password'],$passwordlist)==true) {
	//  				output_notl("`$%s`0",$row['password']);
	//  			} else {
	//  				$passwordlist[]=$row['password'];
	//  				output_notl("%s",$row['password']);
	//  			}
	//  			rawoutput("</td></tr>");
	//  			rawoutput("<tr><td>" . translate_inline("Multiuser:"));
	//  			($row['muallowed']==1)?output('ja'):output('nein');
	//  			rawoutput("</td><td>");
	//  			output_notl($row['emailaddress']);
	//  			rawoutput("</td><td colspan=2>");
	//  			output_notl($row['laston']);
	//  			rawoutput("</td></tr>");
	//  			rawoutput("<tr><td>" . translate_inline("In Arbeit:"));
	//  			rawoutput("<a href='runmodule.php?module=multisearch&op=seteditmode&mode={$row['inprocess']}&id={$row['acctid']}&subop=$orderfield#{$row[$orderfield]}'>");
	//  			($row['inprocess']=="")?output('nein'):output_notl($row['inprocess']);
	//  			rawoutput("</a>");
	//  			addnav("","runmodule.php?module=multisearch&op=seteditmode&mode={$row['inprocess']}&id={$row['acctid']}&subop=$orderfield#{$row[$orderfield]}");
	//  			rawoutput("</td><td colspan=3>");
	//  			if (in_array($row['lastip'],$ip)==true) {
	//  				output_notl("`$%s`0",$row['lastip']);
	//  			} else {
	//  				$ip[]=$row['lastip'];
	//  				output_notl("%s",$row['lastip']);
	//  			}
	//  			rawoutput("</td></tr>");
}
?>